SystemOrganization addCategory: #homeWork!

PackageManifest subclass: #ManifesthomeWork
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork'!

!ManifesthomeWork commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifesthomeWork class methodsFor: 'code-critics' stamp: 'allerSchema 12/19/2018 15:50'!
ruleRBStringConcatenationRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#WidgetClassList #filter:with: #false)) #'2018-12-19T15:50:04.473405+01:00') )! !

ComposableModel subclass: #ClassHierachyWidget
	instanceVariableNames: 'classes labelle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork'!

!ClassHierachyWidget class methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 18:05'!
defaultSpec
	^ SpecRowLayout composed
		add: #classes;
		add: #labelle;
		yourself! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 17:30'!
classes
^classes! !

!ClassHierachyWidget methodsFor: 'as yet unclassified' stamp: 'allerSchema 12/19/2018 17:27'!
drawG
| rootClasses groups v elements edges |
rootClasses := Array with: RTShape with: RTLayout with: RTBuilder.
groups := rootClasses
	collect: [ :cls | 
		| g |
		g := RTGroup new.
		elements := (RTEllipse new
			size: 8;
			color: Color blue) elementsOn: cls withAllSubclasses.
		g addAll: elements.
		edges := RTEdgeBuilder new
			view: g;
			objects: cls withAllSubclasses;
			connectFrom: #superclass.
		RTTreeLayout on: elements edges: edges.
		g ].
v := RTView new.
groups do: [ :aGroup | v addAll: aGroup ].
RTHorizontalLineLayout new
	gapSize: 30;
	on: groups.
RTAlignment new
	elements: groups;
	bottom.
^ v! !

!ClassHierachyWidget methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 18:03'!
initializePresenter
	self classes
		OnClassSelected: [ :item | 
			self drawG.
			labelle label: item name.
			 ]! !

!ClassHierachyWidget methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 17:51'!
initializeWidgets
	classes := self instantiate: WidgetClassList.
	labelle:=self newLabel.
	self focusOrder add: classes.
! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 17:50'!
labelle
^labelle! !

ComposableModel subclass: #WidgetClassList
	instanceVariableNames: 'listClass filtre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork'!

!WidgetClassList class methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:08'!
defaultSpec
	| filtreHeight |
	filtreHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
				
				add: #listClass origin: 0 @ 0.2 corner: 1 @ 1;
				add: #filtre
					origin: 0 @ 0
					corner: 1 @ 0
					offsetOrigin: 0 @ 0
					offsetCorner: 0 @ filtreHeight;
		yourself! !

!WidgetClassList methodsFor: 'api' stamp: 'allerSchema 12/19/2018 17:40'!
OnClassSelected: aBlock
	self listClass whenSelectedItemChanged: aBlock! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:52'!
filter: aCollection with: aText

	^aCollection
		select: [ :cl | 
			(cl name matchesRegex: aText , '.*')
				 ].
	! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 12:25'!
filtre
	^ filtre! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:53'!
initializePresenter
	filtre
		whenTextChanged: [ :text | 
			text = ''
				ifFalse: [ listClass items: (self filter: self listClass listItems with: text , '.*') ]
				ifTrue: [ listClass items: (Object allSubclasses sort:[:a :b|a name<b name])] ]! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:54'!
initializeWidgets
	listClass := self newList.
	filtre := self newTextInput.
	listClass items: (Object allSubclasses sort:[:a :b|a name<b name]).
	filtre
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	self focusOrder
		add: listClass;
		add: filtre! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 11:17'!
listClass
^listClass.! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:54'!
title
^'Listes des classes'! !

TestCase subclass: #WidgetClassListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork'!

!WidgetClassListTest methodsFor: 'as yet unclassified' stamp: 'allerSchema 12/19/2018 16:00'!
testFilter
	"Je permet de test filtre d'une liste "

	self assert: ((WidgetClassList new filter: OrderedCollection allSubclasses with: 'GL') at: 1) equals: GLMMultiValue! !
